/*---------------------------------------
Kodovi u racunarskim telekomunikacijama
       II domaci zadatak, tacka G
"Simulacija binarnog simetricnog kanala"
prema resenju Ivana Milosavljevica 494/97
      (c) Copyright, decembar 2003
-----------------------------------------*/

#include <slucbr.h>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <math>
using namespace std;

int praviBitGreske (float verGre) {
	float slucajni;
	slucajni = (float) urng ();
	if (slucajni > verGre)
		return 0;
	else
		return 1;
}

int main(int argc, char* argv[])
{
	const int MAX_BR_BIT = 220000; //maksimalni broj bitova koji generisemo
	int bitovi[MAX_BR_BIT]; //niz bitova greske
	float verovGreskePoBitu;
	unsigned int stvaranBrojBitova = 0;
	unsigned int ukupanBrojGresaka = 0;
	float apsGreska,
		  relGreska;
	float procenaGreske; //Pe procenjeno posle simulacije
	ofstream rezultati;
	set_urng (148);
	rezultati.open ("2g.dat", ios::out);
    rezultati << "VerGBit\t"
              << "ProcGre\t"
              << "ApsGres\t"
              << "RelGre\t"
              << "BrBitova\t" <<endl;
	for (int i=0; i<5; i++) {
        ukupanBrojGresaka = 0;
		cout << "Verovatnoca greske (0,0005 < pe < 1)? ";
		cin >> verovGreskePoBitu;
		cout << endl;
        stvaranBrojBitova = (110 / verovGreskePoBitu) + 1;
		for (unsigned int j=0; j<stvaranBrojBitova; j++) {
			bitovi[j] = praviBitGreske (verovGreskePoBitu);
			if (bitovi[j] == 1)
               ukupanBrojGresaka++;
		}
		procenaGreske = (float)ukupanBrojGresaka / stvaranBrojBitova;
		apsGreska = procenaGreske - verovGreskePoBitu;
		relGreska = apsGreska / verovGreskePoBitu;
        if (relGreska < 0) relGreska = -relGreska; //ne sme biti negativna
		rezultati << verovGreskePoBitu;
		rezultati << "\t" << procenaGreske;
		rezultati << setprecision(5) << "\t" << apsGreska;
		rezultati << setprecision(5) << "\t" << relGreska;
        rezultati << "\t" << stvaranBrojBitova << endl;
	}
    rezultati.close ();
	return 0;
}
