/*---------------------------------------
Kodovi u racunarskim telekomunikacijama
       II domaci zadatak, tacka V
       "Kanal sa Gausovim sumom"
prema resenju Ivana Milosavljevica 494/97
      (c) Copyright, decembar 2003
-----------------------------------------*/

//---------------------------------------------------------------------------
#pragma hdrstop
//---------------------------------------------------------------------------
#pragma argsused
#include <iostream>
#include <fstream>
#include <dos>
#include <math>
#include "slucbr.h"
using namespace std;

float praviInfBit() {
    double slucajni;
    slucajni = urng ();
    if (slucajni < 0.5)
       return 0;
    else
       return 1;
}

void praviQpskSignal (float& x, float& y) {
      if (x==0 && y==0)
         x = y = 1.0/sqrt(2);
      if (x==0 && y==1) {
         x = -1.0/sqrt(2);
         y = 1.0/sqrt(2);
      }
      if (x==1 && y==0)
         x = y = -1.0/sqrt(2);
      if (x==1 && y==1) {
         x = 1.0/sqrt(2);
         y = -1.0/sqrt(2);
      }
}

void praviNeskaliranSum (float& y1, float& y2) {
     float x1,
           x2; //sluc. promenljive sa uniformnom raspodelom
     float r, theta;
     x1 = urng ();
     x2 = urng ();
     r = sqrt (2 * log (1.0/x1));
     theta = 2 * M_PI * x2;
     y1 = r * sin (theta);
     y2 = r * cos (theta);
}

float VarijansaSuma (int snr) {
      float varijansa;
      float stepen = -snr/20.0;
      varijansa = (1.0/sqrt(2)) * (pow (10, stepen));
      return varijansa;
}

void praviHardOdluku (float& signal1, float& signal2) {
     if (signal1 > 0 && signal2 > 0)
        signal1 = signal2 = 0;
     if (signal1 < 0 && signal2 > 0) {
        signal1 = 0;
        signal2 = 1;
     }
     if (signal1 < 0 && signal2 < 0) {
        signal1 = 1;
        signal2 = 0;
        }
     if (signal1 > 0 && signal2 < 0)
        signal1 = signal2 = 1;
}

int uporediDibite (float inf1, float inf2, float prim1, float prim2) {
    if (inf1 == prim1 && inf2 == prim2)
       return 0;
    else
       return 1;
}

int main(int argc, char* argv[])
{
    set_urng (148);
    const int BR_BIT = 30000;
    int snr = -2; //odnos signal/sum, poc. vrednost po uslovu
    fstream infBitovi, //informacioni bitovi
            qpsk,      //modulisani signal
            sumNeskaliran, //2D sum sa neskaliranim odbircima
            sumJedinicni,  //2D Gausov sum jedinicne snage
            sumPlusQpsk,   //zbir suma i modulisanog signala
            sumPlusQpskBit,//...pretvoreno u bitove
            rezultati,     //pamtimo: snr, br gresaka, verov. greske
            konstelacija;
    long pozInfBitovi, //pamtimo broj bajtova u fajlu... Glupi C++...
         pozSumNeskaliran;
    float varijansaSuma,
          verovatnocaGreske;
    unsigned int brojacGresaka = 0, //
                 brojBitova;    //koliko bitova generisemo

    //pa da pocnemo...
    infBitovi.open ("inf.dat", ios::binary | ios::out);
    for (int i=0; i<BR_BIT; i++) {
        float bitBuffer = praviInfBit ();
        infBitovi.write ((char*) &bitBuffer, sizeof (bitBuffer));
    }
    pozInfBitovi = infBitovi.tellp ();
    infBitovi.close ();//imamo bitove

    //pravimo qpsk
    infBitovi.open ("inf.dat", ios::binary | ios::in | ios::ate);
    infBitovi.seekp (0, ios::beg); //odavde citamo bitove od pocetka fajla
    qpsk.open ("qpsk.dat", ios::binary | ios::out); //ovde upisujemo signale
    while (infBitovi.tellp() < pozInfBitovi) {
        float floatBufferX, floatBufferY;
        infBitovi.read ((char*) &floatBufferX, sizeof (floatBufferX));
        infBitovi.read ((char*) &floatBufferY, sizeof (floatBufferY));
        praviQpskSignal (floatBufferX, floatBufferY);
        qpsk.write ((char*) &floatBufferX, sizeof (floatBufferX));
        qpsk.write ((char*) &floatBufferY, sizeof (floatBufferY));
    } //imamo qpsk signale
    infBitovi.close ();
    qpsk.close ();

    //pravimo neskaliran sum
    sumNeskaliran.open ("sum_ns.dat", ios::binary | ios::out);
    for (int i=0; i<BR_BIT/2; i++) {
        float y1, y2;
        praviNeskaliranSum (y1, y2);
        sumNeskaliran.write ((char*) &y1, sizeof (y1));
        sumNeskaliran.write ((char*) &y2, sizeof (y2));
    } //imamo neskalirani sum
    pozSumNeskaliran = sumNeskaliran.tellp ();
    sumNeskaliran.close ();

    //pocinje skaliranje srednjih vrednosti 2D Gausovog suma
    sumNeskaliran.open ("sum_ns.dat", ios::binary | ios::in);
    sumNeskaliran.seekp (0, ios::beg);
    float m1 = 0,
          m2 = 0; //zbirovi koji sluze za skaliranje odbiraka 2D suma
    while (sumNeskaliran.tellp() < pozSumNeskaliran) {
          float y1, y2;
          sumNeskaliran.read ((char*) &y1, sizeof (y1));
          sumNeskaliran.read ((char*) &y2, sizeof (y2));
          m1 += y1;
          m2 += y2;
    }
    m1 = m1/(BR_BIT/2.0);
    m2 = m2/(BR_BIT/2.0);

    //sad oduzimamo srednje vrednosti od odbiraka
    sumNeskaliran.seekp (0, ios::beg);
    fstream privremeni;
    privremeni.open ("priv.dat", ios::binary | ios::out);
    while (sumNeskaliran.tellp() < pozSumNeskaliran) {
        float y1, y2;
        sumNeskaliran.read ((char*) &y1, sizeof (y1));
        sumNeskaliran.read ((char*) &y2, sizeof (y2));
        y1 -= m1;
        y2 -= m2;
        privremeni.write ((char*) &y1, sizeof(y1));
        privremeni.write ((char*) &y2, sizeof(y2));
    }
    privremeni.close ();
    sumNeskaliran.close ();

    //sad racunamo varijanse odbiraka
    rezultati.open ("rezult.txt", ios::out);
    rezultati << "SNR\tBr.Gres\tVerGres" << endl;
for (snr = -2; snr <= 10; snr++) {
    cout << "Obradjujem slucaj SNR = " << snr << endl;
    privremeni.open ("priv.dat", ios::binary | ios::in | ios::ate);
    privremeni.seekp (0, ios::beg);
    float sigma1 = 0,
          sigma2 = 0; //ovde pamtimo varijanse
    while (privremeni.tellp() < pozSumNeskaliran) {
        float y1, y2;
        privremeni.read ((char*) &y1, sizeof (y1));
        privremeni.read ((char*) &y2, sizeof (y2));
        y1 *= y1;
        y2 *= y2;
        sigma1 += y1;
        sigma2 += y2;
    }
    sigma1 = sigma1 / (BR_BIT/2.0);
    sigma2 = sigma2 / (BR_BIT/2.0);
    varijansaSuma = VarijansaSuma (snr);
    sumJedinicni.open ("sum_jed.dat", ios::binary | ios::out);
    privremeni.seekp (0, ios::beg);
    while (privremeni.tellp() < pozSumNeskaliran) {
        float y1, y2;
        privremeni.read ((char*) &y1, sizeof (y1));
        privremeni.read ((char*) &y2, sizeof (y2));
        y1 = y1 / sigma1;
        y2 = y2 / sigma2;
        y1 *= varijansaSuma;
        y2 *= varijansaSuma;
        sumJedinicni.write ((char*) &y1, sizeof (y1));
        sumJedinicni.write ((char*) &y2, sizeof (y2));
    } //imamo jedinicni sum * varijansa
    privremeni.close ();
    sumJedinicni.close ();

    //sad racunamo zbir suma i qpsk modulisanog signala
    qpsk.open ("qpsk.dat", ios::binary | ios::in);
    sumJedinicni.open ("sum_jed.dat", ios::binary | ios::in);
    sumPlusQpsk.open ("s+q.dat", ios::binary | ios::out);
    qpsk.seekp (0, ios::beg);

    sumJedinicni.seekp (0, ios::beg);
    while (qpsk.tellp() < pozSumNeskaliran && sumJedinicni.tellp() < pozSumNeskaliran) {
          float signalBuffer,
                sumBuffer,
                zbirBuffer;
          qpsk.read ((char*) &signalBuffer, sizeof (signalBuffer));
          sumJedinicni.read ((char*) &sumBuffer, sizeof (sumBuffer));
          zbirBuffer = signalBuffer + sumBuffer;
          sumPlusQpsk.write ((char*) &zbirBuffer, sizeof (zbirBuffer));
    } //imamo zbir suma i qpsk modulisanog signala
    qpsk.close ();
    sumJedinicni.close ();
    sumPlusQpsk.close ();

    if (snr==0 | snr==10) {
       sumPlusQpsk.open ("s+q.dat", ios::binary | ios::in | ios::ate);
       sumPlusQpsk.seekg (0, ios::beg);
       float konstelBufferX, konstelBufferY;
       konstelacija.open ("kons.dat", ios::out | ios::ate);
       konstelacija.seekp (0, ios::beg);
       konstelacija << "X\tY\tSNR= " << snr << endl;
       for (int i=0; i<100; i++) {
           sumPlusQpsk.read ((char*) &konstelBufferX, sizeof (konstelBufferX));
           sumPlusQpsk.read ((char*) &konstelBufferY, sizeof (konstelBufferY));
           konstelacija << konstelBufferX << "\t";
           konstelacija << konstelBufferY << endl;
       }
       konstelacija.close ();
       sumPlusQpsk.close ();
    }
    //sad "hard" odlucujemo
    sumPlusQpsk.open ("s+q.dat", ios::binary | ios::in);
    sumPlusQpskBit.open ("bit_s+q.dat", ios::binary | ios::out);
    sumPlusQpsk.seekp (0, ios::beg);
    while (sumPlusQpsk.tellp() < pozSumNeskaliran) {
          float ssBuffer1,
                ssBuffer2;
          sumPlusQpsk.read ((char*) &ssBuffer1, sizeof (ssBuffer1));
          sumPlusQpsk.read ((char*) &ssBuffer2, sizeof (ssBuffer2));
          praviHardOdluku (ssBuffer1, ssBuffer2);
          sumPlusQpskBit.write ((char*) &ssBuffer1, sizeof(ssBuffer1));
          sumPlusQpskBit.write ((char*) &ssBuffer2, sizeof(ssBuffer2));
    }
    sumPlusQpsk.close ();
    sumPlusQpskBit.close ();
    infBitovi.open ("inf.dat", ios::binary | ios::in);
    sumPlusQpskBit.open ("bit_s+q.dat", ios::binary | ios::in);
    while (infBitovi.tellg() < pozInfBitovi && sumPlusQpskBit.tellp() < pozSumNeskaliran) {
          float infBuffer1, infBuffer2;
          float primBuffer1, primBuffer2;
          infBitovi.read ((char*) &infBuffer1, sizeof (infBuffer1));
          infBitovi.read ((char*) &infBuffer2, sizeof (infBuffer2));
          sumPlusQpskBit.read ((char*) &primBuffer1, sizeof (primBuffer1));
          sumPlusQpskBit.read ((char*) &primBuffer2, sizeof (primBuffer2));
          brojacGresaka += uporediDibite (infBuffer1, infBuffer2, primBuffer1, primBuffer2);
    }
    infBitovi.close ();
    sumPlusQpskBit.close ();

    //ispis rezultata
    rezultati << snr << "\t";
    rezultati << brojacGresaka << "\t";
    verovatnocaGreske = (float)brojacGresaka / BR_BIT;
    rezultati << verovatnocaGreske << endl;
    brojacGresaka = 0;
} //glavna for petlja
    rezultati.close ();
    return 0;
}
//---------------------------------------------------------------------------
