/*---------------------------------------
Kodovi u racunarskim telekomunikacijama
       II domaci zadatak, tacka D
"Simulacija Smit-Boven-Dzojsovog modela kanala"
   prema resenju Ivana Milosavljevica 494/97
      (c) Copyright, decembar 2003
-----------------------------------------*/

#include <slucbr.h>
#include <iostream>
#include <fstream>
#include <dos>
using namespace std;

void RacunajUlStacVerovatnoce
	(float ulVremeBoravka[3], unsigned int X, float ulStacVerovatnoce[3]) {
	float imenilac;
	imenilac = ulVremeBoravka[0] + X*ulVremeBoravka[1] + (1+X)*ulVremeBoravka[2];
    ulStacVerovatnoce[0] = ulVremeBoravka[0]/imenilac;
    ulStacVerovatnoce[1] = X*ulVremeBoravka[1]/imenilac;
    ulStacVerovatnoce[2] = (1+X)*ulVremeBoravka[2]/imenilac;
}

void RacunajTranzicioneVerovatnoce
     (float vremenaBoravka[3], unsigned int X, float tranzVer[3][3]) {
     tranzVer[0][0] = 1 - 1./vremenaBoravka[0];
     tranzVer[1][1] = 1 - 1./vremenaBoravka[1];
     tranzVer[2][2] = 1 - 1./vremenaBoravka[2];
     tranzVer[0][2] = 1 - tranzVer[0][0];
     tranzVer[1][2] = 1 - tranzVer[1][1];
     tranzVer[2][0] = 1. / (vremenaBoravka[2]*(1+X));
     tranzVer[2][1] = X / (vremenaBoravka[2]*(1+X));
}

void RacunajPrelaz0 (unsigned int& stanje, float tranzVer[3][3],
unsigned int brBit[3], unsigned int brUlaz[3]) {
    float slucBr = urng ();
    if (slucBr > tranzVer[0][0]) {
       stanje = 2;
       brUlaz[2]++; //ulaz u novo stanje 2
    }
    else
        brBit[0]++; //jos jedan bit u stanju 0
}

void RacunajPrelaz1 (unsigned int& stanje, float tranzVer[3][3],
unsigned int brBit[3], unsigned int brUlaz[3]) {
    float slucBr = urng ();
    if (slucBr > tranzVer[1][1]) {
       stanje = 2;
       brUlaz[2]++;
    }
    else
        brBit[1]++;
}

void RacunajPrelaz2 (unsigned int& stanje, float tranzVer[3][3],
unsigned int brBit[3], unsigned int brUlaz[3]) {
    float slucBr = urng ();
    if (slucBr < tranzVer[2][0]) {
       stanje = 0;
       brUlaz[0]++;
    }
    if (slucBr > tranzVer[2][0] && slucBr < tranzVer[2][1]) {
       stanje = 1;
       brUlaz[1]++;
    }
    else
        brBit[2]++;
}

short JelGreska (float ulGreska[3], const unsigned int stanje) {
     float slucBr = urng ();
     if (slucBr < ulGreska[stanje])
        return 1;
     else
        return 0;
}

int main(int argc, char* argv[])
{
	//ulazni parametri
	unsigned int stanjeKanala = 0; //0-jako dobro, 1-katastrofa, 2-realno
	unsigned int brojGenerisanihBitova,
				 X; //odnos p21/p20
	float ulVerovGreske[3], //zadata verov. greske po bitu za svako stanje
		  ulVremeBoravka[3],//zadato vreme boravka u svakom stanju
		  ulUkupnaVerovGreske = 0;

	//medjuparametri
	unsigned int brojBitovaPoStanju[3],
				 brojGresakaPoStanju[3],
				 brojUlazakaUStanje[3],
                 ukupanBrojGresaka = 0;
	float ulStacVerovatnoce[3],
		  izlStacVerovatnoce[3],
          tranzicioneVerovatnoce[3][3];

	//izlazni parametri
	float izlVerovGreske[3],
		  izlVremeBoravka[3],
		  izlUkupnaVerovGreske = 0;

	//potrebni fajlovi
	fstream izlSekvencaGresaka,	//greske na izlazu (short)
			izlSekvencaStanja,	//stanja kanala (short)
			rezultati;			//moramo da dobijemo tablicu...

	//pa da pocnemo...
    for (int i=0; i<3; i++) {
        brojBitovaPoStanju[i] = 0;
		brojGresakaPoStanju[i] = 0;
		brojUlazakaUStanje[i] = 0;
        ulStacVerovatnoce[i] = 0;
		izlStacVerovatnoce[i] = 0;
        izlVerovGreske[i] = 0;
		izlVremeBoravka[i] = 0;
    }
	set_urng (148); //postavljamo "klicu" za generator slucajnih br.
for (int prolaz=0; prolaz < 2; prolaz++) {
	cout << "Broj generisanih bitova? ";
	cin >> brojGenerisanihBitova;
	for (int i=0; i<3; i++) {
		cout << "Verovatnoca greske po bitu u stanju " << i << "? ";
		cin >> ulVerovGreske[i];
	}
	for (int i=0; i<3; i++) {
		cout << "Prosecno vreme boravka u stanju " << i << "? ";
		cin >> ulVremeBoravka[i];
	}
	cout << "Odnos p21/p20? ";
	cin >> X;
	cout << endl;
	RacunajUlStacVerovatnoce (ulVremeBoravka, X, ulStacVerovatnoce);
    ulUkupnaVerovGreske = ulStacVerovatnoce[0]*ulVerovGreske[0] +
                          ulStacVerovatnoce[1]*ulVerovGreske[1] +
                          ulStacVerovatnoce[2]*ulVerovGreske[2];
    //racunamo tranzicione verovatnoce
    RacunajTranzicioneVerovatnoce (ulVremeBoravka, X, tranzicioneVerovatnoce);

	//racunamo eventualne prelaze iz stanja u stanje
    izlSekvencaGresaka.open ("izl_gre.dat", ios::out);
    izlSekvencaStanja.open ("izl_sta.dat", ios::out);
	for (unsigned int i=0; i < brojGenerisanihBitova; i++) {
        switch (stanjeKanala) {
               case 0: {
                    RacunajPrelaz0 (stanjeKanala, tranzicioneVerovatnoce,
                    brojBitovaPoStanju, brojUlazakaUStanje);
                    break;
               }
               case 1: {
                    RacunajPrelaz1 (stanjeKanala, tranzicioneVerovatnoce,
                    brojBitovaPoStanju, brojUlazakaUStanje);
                    break;
               }
               case 2: {
                    RacunajPrelaz2 (stanjeKanala, tranzicioneVerovatnoce,
                    brojBitovaPoStanju, brojUlazakaUStanje);
                    break;
               }
        } //end switch
        if (JelGreska (ulVerovGreske, stanjeKanala) == 1) {
            short s = 1;
            brojGresakaPoStanju[stanjeKanala]++;
            izlSekvencaGresaka << s;
        }
        else {
            short s = 0;
            izlSekvencaGresaka << s;
        }
        izlSekvencaStanja << (short)stanjeKanala;
    } //end for
    izlSekvencaGresaka.close ();
    izlSekvencaStanja.close ();

    //racunanje izlaznih parametara
    for (int i=0; i<3; i++) {
        ukupanBrojGresaka += brojGresakaPoStanju[i];
        izlVerovGreske[i] = ((float)brojGresakaPoStanju[i]) / brojBitovaPoStanju[i];
        izlVremeBoravka[i] = ((float)brojBitovaPoStanju[i]) / brojUlazakaUStanje[i];
        izlStacVerovatnoce[i] = ((float)brojBitovaPoStanju[i]) / brojGenerisanihBitova;
	}
    izlUkupnaVerovGreske = ((float)ukupanBrojGresaka) / brojGenerisanihBitova;

    //ispis rezultata
    rezultati.open ("rezult.txt", ios::out | ios::app);
    //ulazni parametri
    rezultati << "Ulazni parametri:" << endl;
    rezultati << "-----------------" << endl;
    rezultati << "N= " << brojGenerisanihBitova << endl;
    rezultati << "X= " << X << endl;
    rezultati << "Pe0: " << ulVerovGreske[0] << endl;
    rezultati << "Pe1: " << ulVerovGreske[1] << endl;
    rezultati << "Pe2: " << ulVerovGreske[2] << endl;
    rezultati << "T0: " << ulVremeBoravka[0] << endl;
    rezultati << "T1: " << ulVremeBoravka[1] << endl;
    rezultati << "T2: " << ulVremeBoravka[2] << endl;
    rezultati << "P(0): " << ulStacVerovatnoce[0] << endl;
    rezultati << "P(1): " << ulStacVerovatnoce[1] << endl;
    rezultati << "P(2): " << ulStacVerovatnoce[2] << endl;
    rezultati << "Pe: " << ulUkupnaVerovGreske << endl;
    //izlazni parametri
    rezultati << "\nIzlazni parametri:" << endl;
    rezultati << "------------------" << endl;
    rezultati << "pe0: " << izlVerovGreske[0] << endl;
    rezultati << "pe1: " << izlVerovGreske[1] << endl;
    rezultati << "pe2: " << izlVerovGreske[2] << endl;
    rezultati << "T0: " << izlVremeBoravka[0] << endl;
    rezultati << "T1: " << izlVremeBoravka[1] << endl;
    rezultati << "T2: " << izlVremeBoravka[2] << endl;
    cout << endl;
    rezultati << "P(0): " << izlStacVerovatnoce[0] << endl;
    rezultati << "P(1): " << izlStacVerovatnoce[1] << endl;
    rezultati << "P(2): " << izlStacVerovatnoce[2] << endl;
    rezultati << "Pe: " << izlUkupnaVerovGreske << endl;
    rezultati << "Broj ulazaka[0]: " << brojUlazakaUStanje[0] << endl;
    rezultati << "Broj ulazaka[1]: " << brojUlazakaUStanje[1] << endl;
    rezultati << "Broj ulazaka[2]: " << brojUlazakaUStanje[2] << endl;
    rezultati.close ();
} //end for - za 2 prolaza   

    return 0;
}
